/**
* @par Copyright (C): 2010-2019, Shenzhen Yahboom Tech
* @file         ColorLED.c
* @author       Danny
* @version      V1.0
* @date         2017.08.16
* @brief        ߲̽յʵ
* @details
* @par History  ˵
*/
#include "STC12C5A60S2.H"

#define ON 1     //ʹLED
#define OFF 0    //ֹLED

//RGB߲ʵ
sbit LED_R = P4^6;	//LED_RSTC12C5A60S2EAP4^6ܽ
sbit LED_G = P4^5;  //LED_GSTC12C5A60S2ALEP4^5ܽ
sbit LED_B = P4^4;	//LED_BSTC12C5A60S2PSENP4^4ܽ

/**
* Function       delay
* @author        Danny
* @date          2017.08.16
* @brief         ʱ
* @param         xmsʱʱ䣨ms
* @retval        void
* @par History   
*/
 void delay(unsigned int xms)				
{
	unsigned int i,j;
	for(i=xms;i>0;i--)		     
		for(j=900;j>0;j--);
}

/**
* Function       color_led
* @author        Danny
* @date          2017.08.16
* @brief         R,G,BɫĲͬγ7ֲͬɫ
* @param[in1]    Red
* @param[in2]    Green
* @param[in3]    Blue
* @retval        void
* @par History   
*/
void color_led(int v_iRed, int v_iGreen, int v_iBlue)
{
    //ɫLED
	v_iRed == ON ? (LED_R = 1): (LED_R = 0);
 
    //ɫLED
	v_iGreen == ON ? (LED_G = 1): (LED_G = 0);
  
    //ɫLED
	v_iBlue == ON ? (LED_B = 1): (LED_B = 0);
}

/**
* Function       main
* @author        Danny
* @date          2017.08.16
* @brief         ѭ7ɫLED
* @param[in]     void
* @retval        void
* @par History   
*/
int main()
{     
    //P4ΪͨIOʹ
	P4SW |= (1<<4);
	P4SW |= (1<<5);
	P4SW |= (1<<6);
	
	//P4Ϊǿģʽ
	P4M1 &= ~(1<<4); 
	P4M1 &= ~(1<<5);
	P4M1 &= ~(1<<6);

   	P4M0 |= (1<<4);
   	P4M0 |= (1<<5);
   	P4M0 |= (1<<6);
	
	while (1)
	{                            // LED_R   LED_G    LED_B
		color_led(ON, OFF, OFF); //   1        0        0
    	delay(1000);
    	color_led(OFF, ON, OFF); //   0        1        0
    	delay(1000);
    	color_led(OFF, OFF, ON); //   0        0        1
    	delay(1000);
    	color_led(ON, ON, OFF);  //   1        1        0
    	delay(1000);
    	color_led(ON, OFF, ON);  //   1        0        1
    	delay(1000);
    	color_led(OFF, ON, ON);  //   0        1        1
    	delay(1000);
    	color_led(ON, ON, ON);   //   1        1        1
		delay(1000);
		color_led(OFF, OFF, OFF);   //   1        1        1	
	}					   	
	return 0;	
}
